using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Bus_VisitResultRecords
	/// </summary>
	public partial class T_Bus_VisitResultRecords
    {
        public T_Bus_VisitResultRecords()
        { }
        #region  BasicMethod

        /// <summary>
		/// 增加一条数据
		/// </summary>
		public int Add(CallCenterApi.Model.T_Bus_VisitResultRecords model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Bus_VisitResultRecords(");
            strSql.Append("F_VRId,F_WorkOrderId,F_AssignedId,F_VisitUser,F_Type,F_IsSatisfie,F_Result,F_LimitTime,F_CallRecordId,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_File,F_ReUser,F_ReTime,F_CallId,F_Guid)");
            strSql.Append(" values (");
            strSql.Append("@F_VRId,@F_WorkOrderId,@F_AssignedId,@F_VisitUser,@F_Type,@F_IsSatisfie,@F_Result,@F_LimitTime,@F_CallRecordId,@F_Remark,@F_State,@F_CreateUser,@F_CreateTime,@F_IsDelete,@F_DeleteUser,@F_DeleteTime,@F_File,@F_ReUser,@F_ReTime,@F_CallId,@F_Guid)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_VRId", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_AssignedId", SqlDbType.Int,4),
                    new SqlParameter("@F_VisitUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_IsSatisfie", SqlDbType.Int,4),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CallRecordId", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_File", SqlDbType.VarChar,500),
                    new SqlParameter("@F_ReUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ReTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CallId", SqlDbType.Int,4),
                    new SqlParameter("@F_Guid", SqlDbType.NVarChar,32)};
            parameters[0].Value = model.F_VRId;
            parameters[1].Value = model.F_WorkOrderId;
            parameters[2].Value = model.F_AssignedId;
            parameters[3].Value = model.F_VisitUser;
            parameters[4].Value = model.F_Type;
            parameters[5].Value = model.F_IsSatisfie;
            parameters[6].Value = model.F_Result;
            parameters[7].Value = model.F_LimitTime;
            parameters[8].Value = model.F_CallRecordId;
            parameters[9].Value = model.F_Remark;
            parameters[10].Value = model.F_State;
            parameters[11].Value = model.F_CreateUser;
            parameters[12].Value = model.F_CreateTime;
            parameters[13].Value = model.F_IsDelete;
            parameters[14].Value = model.F_DeleteUser;
            parameters[15].Value = model.F_DeleteTime;
            parameters[16].Value = model.F_File;
            parameters[17].Value = model.F_ReUser;
            parameters[18].Value = model.F_ReTime;
            parameters[19].Value = model.F_CallId;
            parameters[20].Value = model.F_Guid;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_VisitResultRecords GetModel(int F_VRRId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_VRRId,F_VRId,F_WorkOrderId,F_AssignedId,F_VisitUser,F_Type,F_IsSatisfie,F_Result,F_LimitTime,F_CallRecordId,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_File,F_ReUser,F_ReTime,F_CallId,F_Guid from T_Bus_VisitResultRecords ");
            strSql.Append(" where F_VRRId=@F_VRRId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_VRRId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_VRRId;

            CallCenterApi.Model.T_Bus_VisitResultRecords model = new CallCenterApi.Model.T_Bus_VisitResultRecords();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_VisitResultRecords DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Bus_VisitResultRecords model = new CallCenterApi.Model.T_Bus_VisitResultRecords();
            if (row != null)
            {
                if (row["F_VRRId"] != null && row["F_VRRId"].ToString() != "")
                {
                    model.F_VRRId = int.Parse(row["F_VRRId"].ToString());
                }
                if (row["F_VRId"] != null && row["F_VRId"].ToString() != "")
                {
                    model.F_VRId = int.Parse(row["F_VRId"].ToString());
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_AssignedId"] != null && row["F_AssignedId"].ToString() != "")
                {
                    model.F_AssignedId = int.Parse(row["F_AssignedId"].ToString());
                }
                if (row["F_VisitUser"] != null)
                {
                    model.F_VisitUser = row["F_VisitUser"].ToString();
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_IsSatisfie"] != null && row["F_IsSatisfie"].ToString() != "")
                {
                    model.F_IsSatisfie = int.Parse(row["F_IsSatisfie"].ToString());
                }
                if (row["F_Result"] != null)
                {
                    model.F_Result = row["F_Result"].ToString();
                }
                if (row["F_LimitTime"] != null && row["F_LimitTime"].ToString() != "")
                {
                    model.F_LimitTime = DateTime.Parse(row["F_LimitTime"].ToString());
                }
                if (row["F_CallRecordId"] != null && row["F_CallRecordId"].ToString() != "")
                {
                    model.F_CallRecordId = int.Parse(row["F_CallRecordId"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_DeleteUser"] != null)
                {
                    model.F_DeleteUser = row["F_DeleteUser"].ToString();
                }
                if (row["F_DeleteTime"] != null && row["F_DeleteTime"].ToString() != "")
                {
                    model.F_DeleteTime = DateTime.Parse(row["F_DeleteTime"].ToString());
                }
                if (row["F_File"] != null)
                {
                    model.F_File = row["F_File"].ToString();
                }
                if (row["F_ReUser"] != null)
                {
                    model.F_ReUser = row["F_ReUser"].ToString();
                }
                if (row["F_ReTime"] != null && row["F_ReTime"].ToString() != "")
                {
                    model.F_ReTime = DateTime.Parse(row["F_ReTime"].ToString());
                }
                if (row["F_CallId"] != null && row["F_CallId"].ToString() != "")
                {
                    model.F_CallId = int.Parse(row["F_CallId"].ToString());
                }
                if (row["F_Guid"] != null)
                {
                    model.F_Guid = row["F_Guid"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_VRRId,F_VRId,F_WorkOrderId,F_AssignedId,F_VisitUser,F_Type,F_IsSatisfie,F_Result,F_LimitTime,F_CallRecordId,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_File,F_ReUser,F_ReTime,F_CallId,F_Guid ");
            strSql.Append(" FROM T_Bus_VisitResultRecords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_VRRId,F_VRId,F_WorkOrderId,F_AssignedId,F_VisitUser,F_Type,F_IsSatisfie,F_Result,F_LimitTime,F_CallRecordId,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_File,F_ReUser,F_ReTime,F_CallId,F_Guid ");
            strSql.Append(" FROM T_Bus_VisitResultRecords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Bus_VisitResultRecords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_VRRId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Bus_VisitResultRecords T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
